package com.example.fuzzbackendmaster.controller;

import com.example.fuzzbackendmaster.pojo.vo.AjaxResult;
import com.example.fuzzbackendmaster.pojo.vo.CmdStartParams;
import com.example.fuzzbackendmaster.pojo.vo.TestEntity;
import com.example.fuzzbackendmaster.service.FuzzIntegrationFileApi;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

@Slf4j
@RestController
@RequestMapping("/testmission")
@CrossOrigin
public class TestMissionController {
    @Autowired
    FuzzIntegrationFileApi fuzzIntegrationFileApi;
    /**
     * 新建测试
     */
    @RequestMapping(value = "/startmission", method = RequestMethod.GET)
    public AjaxResult getAll(@RequestParam int id) {
        return fuzzIntegrationFileApi.startmission(id);
    }
    /**
     * 获取全部测试信息
     */
    @RequestMapping(value = "/getAll", method = RequestMethod.GET)
    public AjaxResult getAll() {
        return fuzzIntegrationFileApi.getTestAndParamsList();
    }

    /**
     * 跟据id删除测试信息
     */
    @RequestMapping(value = "/deleteById", method = RequestMethod.GET)
    public AjaxResult deleteById(@RequestParam int id) {
        return fuzzIntegrationFileApi.deleteById(id);
    }

    /**
     * 新建测试，由测试名新建空白测试
     */
    @RequestMapping(value = "/insert", method = RequestMethod.GET)
    public AjaxResult insertTest(@RequestParam String testname) {
        return fuzzIntegrationFileApi.insert(testname);
    }

    /**
     * 给aflent相关测试配置参数
     */
    @RequestMapping(value = "/insertWithAflnet/{id}", method = RequestMethod.POST)
    public AjaxResult insertParmasInTestAflnet(@PathVariable("id") int id, @RequestBody final CmdStartParams cmdStartParams) {
        return fuzzIntegrationFileApi.insertParmasInTestAflnet(id, cmdStartParams);
    }

    /**
     * 给kitty相关测试配置参数
     */
    @RequestMapping(value = "/insertWithkitty/{id}", method = RequestMethod.POST)
    public AjaxResult insertParmasInTestKitty(@PathVariable("id") int id, @RequestBody TestEntity testEntity) {
        return fuzzIntegrationFileApi.insertParmasInTestKitty(id, testEntity);
    }
    /**
     * 测试名称修改
     */
    @RequestMapping(value = "/editTestName", method = RequestMethod.GET)
    public AjaxResult editTestName(@RequestParam String testName,@RequestParam int id) {
        return fuzzIntegrationFileApi.editTestName(testName, id);
    }
}
